Compare commits

...

19 Commits

Author SHA1 Message Date
Jack L. Frost 19f6c5249a remove debug stuff
Signed-off-by: fbt <fbt@fleshless.org>
2022-12-28 04:19:58 +00:00
Jack L. Frost 823a2847c8 encode all the stuff
Signed-off-by: fbt <fbt@fleshless.org>
2022-12-28 04:16:26 +00:00
Jack L. Frost 6e2c506e72 alignment
Signed-off-by: fbt <fbt@fleshless.org>
2022-04-18 10:25:48 +00:00
Jack L. Frost 3f094a2b47 xclip selector selector :>
Signed-off-by: fbt <fbt@fleshless.org>
2021-10-06 13:49:35 +03:00
Jack L. Frost cd5f695936 clipboard option
Signed-off-by: fbt <fbt@fleshless.org>
2021-10-06 13:40:45 +03:00
Jack L. Frost 8aea6446bb forgot this one
Signed-off-by: fbt <fbt@fleshless.org>
2021-10-06 13:22:17 +03:00
Jack L. Frost fb38496fe9 just return 1
Signed-off-by: fbt <fbt@fleshless.org>
2021-04-19 16:14:19 +03:00
Jack L. Frost df4e1d0370 Smarter args
Signed-off-by: fbt <fbt@fleshless.org>
2020-10-03 19:44:19 +03:00
Jack L. Frost b63ae67204 it's actually just format
Signed-off-by: fbt <fbt@fleshless.org>
2020-08-21 15:42:52 +03:00
Jack L. Frost f103e564dc readme
Signed-off-by: fbt <fbt@fleshless.org>
2020-05-24 04:36:13 +03:00
Jack L. Frost 176b80fcf6 Actually, to hell with this sugar stuff
Signed-off-by: fbt <fbt@fleshless.org>
2020-05-24 04:21:39 +03:00
Jack L. Frost 3ac25bbeb2 simpler sugar
Signed-off-by: fbt <fbt@fleshless.org>
2020-05-24 03:57:17 +03:00
Jack L. Frost 522dc0e1f6 group curl settings and make em configurable at the same time
Signed-off-by: fbt <fbt@fleshless.org>
2020-05-24 03:43:39 +03:00
Jack L. Frost 6e9046367f wut
Signed-off-by: fbt <fbt@fleshless.org>
2019-12-04 14:14:13 +03:00
Jack L. Frost 67ddff1306 indentation
Signed-off-by: fbt <fbt@fleshless.org>
2019-12-04 14:13:03 +03:00
Jack L. Frost c89d90f67c Just use this in a wrapper; this was a bad idea
Signed-off-by: fbt <fbt@fleshless.org>
2019-12-04 14:12:01 +03:00
Jack L. Frost 2beb1c0638 these have no reason not to be flags
Signed-off-by: fbt <fbt@fleshless.org>
2019-11-26 01:53:22 +03:00
Jack L. Frost 8804a855b3 and some other stuff
Signed-off-by: fbt <fbt@fleshless.org>
2019-11-26 01:49:12 +03:00
Jack L. Frost 7858829ec4 support setting the secret in env vars
Signed-off-by: fbt <fbt@fleshless.org>
2019-11-26 01:46:00 +03:00
4 changed files with 116 additions and 102 deletions

View File

@ -18,6 +18,8 @@ Call ufw -h for help.
Dependencies: curl, jq Dependencies: curl, jq
The config goes into `$XDG_CONFIG_DIR/ufw`.
ufwd ufwd
---- ----

11
config/ufw Normal file
View File

@ -0,0 +1,11 @@
# Put your actual secret here, this is just a random string
secret='rooxoosh7Aese7phiPh3Choh3uthiTha'
# Override the default common curl behaviour:
#curl() { command curl -sL "$@"; }
#cfg_tmp_dir="$XDG_RUNTIME_DIR/ufw"
#cfg_service_url='https://8fw.me'
#cfg_max_filesize='200M' # Local limit, doesn't affect the server one :)
#flag_shortlink=0 # Display short links
#flag_directlink=1 # Display direct file links

204
ufw
View File

@ -23,15 +23,14 @@ msg() {
err() { printf '(error) %s\n' "$*" >&2; } err() { printf '(error) %s\n' "$*" >&2; }
curl() { command curl -sL "$@"; }
usage() { usage() {
_cat <<- EOF _cat <<- EOF
Usage: ufw [-RsF] [-D num] [file/url]" Usage: ufw [-RsF] [-D num] [file/url]
Flags: Flags:
-R|--remove-file # Remove the file after uploading. -R|--remove-file # Remove the file after uploading.
-s|--screenshot # Make a screenshot and upload it instead of a file.
-F|--fullscreen # Make a fullscreen shot instead of prompting for a window/area. Implies -s.
-d|--description # Supply a description. -d|--description # Supply a description.
-D|--screenshot-delay <num> # Delay the shot by <num> seconds.
-p|--public # Make the file public. -p|--public # Make the file public.
-n|--no-notify # Don't send immediate notifications for this upload. -n|--no-notify # Don't send immediate notifications for this upload.
--notify # Force a notification for this upload. --notify # Force a notification for this upload.
@ -44,10 +43,10 @@ usage() {
-t|--tags "<tag1[, tag2,..]>" # Add tags to the file. -t|--tags "<tag1[, tag2,..]>" # Add tags to the file.
-q|--quiet # Be quiet. -q|--quiet # Be quiet.
-v|--void # Don't add the file to my files. -v|--void # Don't add the file to my files.
-c|--clipboard # Throw the result into the clipboard
Config options (~/.config/ufw): Config options (~/.config/ufw):
secret # Your personal token. Get it at https://zfh.so/settings_form secret # Your personal token. Get it at https://zfh.so/settings_form
cfg_screenshot_ext # Screenshot file type, used by maim.
cfg_max_filesize # Maximum filesize (takes K, M and G suffixes). cfg_max_filesize # Maximum filesize (takes K, M and G suffixes).
# Others are self-explanatory: # Others are self-explanatory:
cfg_url_regex cfg_url_regex
@ -56,6 +55,9 @@ usage() {
Environment variables: Environment variables:
UFW_CFG_FILE # Config file to read, defaults to \$XDG_CONFIG_DIR/ufw UFW_CFG_FILE # Config file to read, defaults to \$XDG_CONFIG_DIR/ufw
UFW_SECRET # Your API secret
UFW_TMP_DIR
UFW_URL
EOF EOF
} }
@ -82,7 +84,10 @@ get_max_filesize() {
get_album_id() { get_album_id() {
declare api_response api_status api_status_message declare api_response api_status api_status_message
api_response=$( curl -fsL "$cfg_service_url/albumctl.json?m=new&name=$1&secret=$secret" ) api_response=$( curl --get \
--data-urlencode "name=$1" \
--data-urlencode "secret=$secret" \
"$cfg_service_url/albumctl.json?m=new" )
get_api_status <<< "$api_response" get_api_status <<< "$api_response"
@ -98,42 +103,37 @@ get_album_id() {
upload() { upload() {
declare api_response api_status api_status_message declare api_response api_status api_status_message
if (( flag_scn )); then (( $# )) || {
usage
return 1
}
target="$1"
if is_url "$target"; then
flag_rm=1 flag_rm=1
file=$(take_screenshot) || { return 1; } file=$(_mktemp "$cfg_tmp_dir")
get_max_filesize || { return 1; }
curl --max-filesize "$max_filesize_bytes" "$target" > "$file"
curl_result=$?
if (( curl_result )); then
case "$curl_result" in
63) err "File exceeds cfg_max_filesize";;
*) err "Could not download file.";;
esac
return 1
fi
else else
(( $# )) || { file="$target"
usage
[[ -f "$file" ]] || {
err "No such file: ${file}"
return 1 return 1
} }
target="$1"
if is_url "$target"; then
flag_rm=1
file=$(_mktemp "$cfg_tmp_dir")
get_max_filesize || { return 1; }
curl --max-filesize "$max_filesize_bytes" -sL "$target" > "$file"
curl_result=$?
if (( curl_result )); then
case "$curl_result" in
63) err "File exceeds cfg_max_filesize";;
*) err "Could not download file.";;
esac
return 1
fi
else
file="$target"
[[ -f "$file" ]] || {
err "No such file: ${file}"
return 1
}
fi
fi fi
get_file_hash "$file" get_file_hash "$file"
@ -142,9 +142,9 @@ upload() {
get_album_id "$album_name" get_album_id "$album_name"
fi fi
api_response=$( curl -sL \ api_response=$( curl \
-F file="@$file" \ -F file="@$file" \
-F api_format='json' \ -F format='json' \
-F flag_private="$flag_private" \ -F flag_private="$flag_private" \
-F secret="$secret" \ -F secret="$secret" \
-F tags="$tags" \ -F tags="$tags" \
@ -174,6 +174,8 @@ upload() {
(( flag_directlink )) || file_link="${file_link#*.}" (( flag_directlink )) || file_link="${file_link#*.}"
} }
(( flag_clipboard )) && xclip "${xclip_args[@]}" <<< "$file_link"
printf '%s\n' "$file_link" printf '%s\n' "$file_link"
if (( flag_rm )); then if (( flag_rm )); then
@ -189,42 +191,24 @@ upload() {
get_shortlink() { get_shortlink() {
declare url=$1 api_response api_status api_status_message declare url=$1 api_response api_status api_status_message
api_response=$( curl -sL "$cfg_service_url/shrink.json?url=${url}&secret=$secret" ) api_response=$( curl --data-urlencode "url=$url" \
--data-urlencode "secret=$secret" \
"$cfg_service_url/shrink.json" )
get_api_status <<< "$api_response" get_api_status <<< "$api_response"
if (( api_status == 200 )); then if (( api_status == 200 )); then
read -r short_url real_url < <( read -r short_url real_url < <(
jq -r '.data.short_url' <<< "$api_response" jq -r '.data.short_url' <<< "$api_response"
) )
(( flag_clipboard )) && xclip "${xclip_args[@]}" <<< "$short_url"
printf '%s\n' "$short_url" printf '%s\n' "$short_url"
else else
printf 'Error: %s %s\n' "$api_status" "$api_status_message" printf 'Error: %s %s\n' "$api_status" "$api_status_message"
fi fi
} }
take_screenshot() {
declare tmp_file
[[ "$scn_exec" ]] || { scn_exec=$(type -P maim); }
[[ "$scn_exec" ]] || {
err "Please install maim to use this function"
return 1
}
(( "$flag_scn_fullscreen" )) || { scn_args+=( '-s' ); }
[[ "$cfg_scn_delay" ]] && { scn_args+=( "-d" "$cfg_scn_delay" ); }
tmp_file="$(_mktemp "${cfg_tmp_dir}" ".${cfg_screenshot_ext}")"
maim "${scn_args[@]}" "$tmp_file" || {
err "Failed to take a screenshot."
return 1
}
printf '%s\n' "$tmp_file"
}
get_api_status() { get_api_status() {
read -d '' -r api_status api_status_message < <( read -d '' -r api_status api_status_message < <(
jq -r '.status.code, .status.message' jq -r '.status.code, .status.message'
@ -253,12 +237,13 @@ _mktemp() {
get_my_ip() { get_my_ip() {
declare api_response api_status api_status_message my_ip declare api_response api_status api_status_message my_ip
api_response=$( curl -sl "$cfg_service_url/ip.json" ) api_response=$( curl "$cfg_service_url/ip.json" )
get_api_status <<< "$api_response" get_api_status <<< "$api_response"
if (( api_status == 200 )); then if (( api_status == 200 )); then
my_ip=$( jq -r '.data.ip' <<< "$api_response" ) my_ip=$( jq -r '.data.ip' <<< "$api_response" )
(( flag_clipboard )) && xclip "${xclip_args[@]}" <<< "$my_ip"
printf '%s\n' "$my_ip" printf '%s\n' "$my_ip"
else else
printf 'Error: %s %s\n' "$api_status" "$api_status_message" printf 'Error: %s %s\n' "$api_status" "$api_status_message"
@ -268,7 +253,7 @@ get_my_ip() {
login() { login() {
declare api_response declare api_response
api_response=$( curl -sl "$cfg_service_url/token_request.json?login=$login" ) api_response=$( curl "$cfg_service_url/token_request.json?login=$login" )
if get_api_status <<< "$api_response"; then if get_api_status <<< "$api_response"; then
printf 'Check your email.\n' printf 'Check your email.\n'
@ -316,7 +301,7 @@ set_argv() {
unset -v arg opt c unset -v arg opt c
case "$1" in case "$1" in
(--) argv+=( "$1" ); break;; (--) argv+=( "$1" ); shift; break;;
(--*) (--*)
IFS='=' read arg opt <<< "$1" IFS='=' read arg opt <<< "$1"
@ -341,10 +326,14 @@ set_argv() {
esac esac
shift shift
done done
if (( $# )); then
argv+=( "$@" )
fi
} }
main() { main() {
declare args file target flag_private flag_rm flag_scn flag_scn_fullscreen cfg_scn_delay flag_notify declare args file target flag_private flag_rm flag_notify
declare flag_shortlink declare flag_shortlink
# Defaults for XDG # Defaults for XDG
@ -359,12 +348,16 @@ main() {
cfg_url_regex='^[A-Za-z]([A-Za-z0-9+.-]+)?://.+' cfg_url_regex='^[A-Za-z]([A-Za-z0-9+.-]+)?://.+'
cfg_file=${UFW_CFG_FILE:-"$XDG_CONFIG_DIR/ufw"} cfg_file=${UFW_CFG_FILE:-"$XDG_CONFIG_DIR/ufw"}
[[ $UFW_SECRET ]] && secret=$UFW_SECRET
[[ $UFW_TMP_DIR ]] && cfg_tmp_dir=$UFW_TMP_DIR
[[ $UFW_URL ]] && cfg_service_url=$UFW_URL
[[ $1 ]] || { usage; return 1; } [[ $1 ]] || { usage; return 1; }
if [[ -f "$cfg_file" ]]; then if [[ -f "$cfg_file" ]]; then
if ! source "$cfg_file"; then if ! source "$cfg_file"; then
printf 'Failed to source configuration file: %s\n' "$cfg_file" printf 'Failed to source configuration file: %s\n' "$cfg_file"
return $? return 1
fi fi
fi fi
@ -372,44 +365,46 @@ main() {
: ${cfg_file:="$XDG_CONFIG_DIR/ufw"} : ${cfg_file:="$XDG_CONFIG_DIR/ufw"}
: ${cfg_tmp_dir:="$XDG_RUNTIME_DIR/ufw"} : ${cfg_tmp_dir:="$XDG_RUNTIME_DIR/ufw"}
: ${cfg_service_url:='https://8fw.me'} : ${cfg_service_url:='https://8fw.me'}
: ${cfg_screenshot_ext:='png'}
: ${cfg_max_filesize:='200M'} : ${cfg_max_filesize:='200M'}
: ${flag_shortlink:=0} : ${flag_shortlink:=0}
: ${flag_directlink:=1} : ${flag_directlink:=1}
: ${flag_clipboard:=0}
: ${xclip_selector:='clipboard'}
while [[ "$1" ]]; do while [[ "$1" ]]; do
case "$1" in case "$1" in
-h|--help|--usage) usage; return;; (-h|--help|--usage) usage; return;;
-D|--screenshot-delay) cfg_scn_delay="$2"; shift;; (-m|--max-filesize) cfg_max_filesize=$2; shift;;
-m|--max-filesize) cfg_max_filesize=$2; shift;; (-A|--album-name) album_name=$2; shift;;
-A|--album-name) album_name=$2; shift;; (-t|--tags) tags=$2; shift;;
-t|--tags) tags=$2; shift;;
-i|--my-ip) action='getmyip';; (--tmp-dir) cfg_tmp_dir=$2; shift;;
-u|--shorten) action='url';; (--url) cfg_service_url=$2; shift;;
(--max-filesize) cfg_max_filesize=$2; shift;;
-p|--public) flag_private='false';; (-i|--my-ip) action='getmyip';;
-R|--remove-file) flag_rm='1';; (-u|--shorten) action='url';;
-s|--screenshot) flag_scn='1';;
-S|--short-url) flag_shortlink=1;;
-P|--page-url) flag_directlink=0;;
-q|--quiet) flag_quiet=1;;
-v|--void) flag_void=1;;
--notify) flag_notify=1;; (-p|--public) flag_private='false';;
--no-notify|-n) flag_notify=0;; (-R|--remove-file) flag_rm='1';;
(-S|--short-url) flag_shortlink=1;;
(-P|--page-url) flag_directlink=0;;
(-q|--quiet) flag_quiet=1;;
(-v|--void) flag_void=1;;
-F|--fullscreen) # Clipboard
flag_scn='1' (-c|--clipboard) flag_clipboard=1;;
flag_scn_fullscreen='1' (-C|--xclip-selector) xclip_selector=$2; shift;;
;;
-a|--album-id) (--notify) flag_notify=1;;
(--no-notify|-n) flag_notify=0;;
(-a|--album-id)
misc_curl_args+=( -F "album_id=$2" ) misc_curl_args+=( -F "album_id=$2" )
shift shift
;; ;;
-d|--description) (-d|--description)
misc_curl_args+=( -F "description=$2" ) misc_curl_args+=( -F "description=$2" )
shift shift
;; ;;
@ -422,11 +417,19 @@ main() {
return 1 return 1
;; ;;
*) break;; *) args+=( "$1" );;
esac esac
shift shift
done done
xclip_args+=( -selection "$xclip_selector" )
# Catch the args after --
if (( $# )); then
args+=( "$@" )
shift
fi
TEMPDIR="$cfg_tmp_dir" TEMPDIR="$cfg_tmp_dir"
for i in "$cfg_tmp_dir"; do for i in "$cfg_tmp_dir"; do
@ -436,21 +439,18 @@ main() {
case "${action:-upload}" in case "${action:-upload}" in
upload) upload)
get_token || return $? get_token || return $?
(( ${#args[@]} )) || return 1
if (( $# )); then for t in "${args[@]}"; do
for t in "$@"; do upload "$t"
upload "$t" done
done
else
upload
fi
;; ;;
url) url)
get_token || return $? get_token || return $?
for t in "$@"; do for t in "${args[@]}"; do
get_shortlink "$1" get_shortlink "$t"
done done
;; ;;

1
ufwd
View File

@ -14,6 +14,7 @@ usage() {
printf ' -h # Show this message.\n' printf ' -h # Show this message.\n'
printf ' -n # Enable notifications with notify-send. Must be installed.\n' printf ' -n # Enable notifications with notify-send. Must be installed.\n'
printf ' -d [path] # Set the dir that is to be watched.\n' printf ' -d [path] # Set the dir that is to be watched.\n'
printf ' -s # Push the file url into the clipboard.\n'
} }
upload() { upload() {